/*
Copyright (c) 2020 Red Hat, Inc.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

  http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// IMPORTANT: This file has been generated automatically, refrain from modifying it manually as all
// your changes will be lost when the file is generated again.

package v1 // github.com/openshift-online/ocm-sdk-go/clustersmgmt/v1

// AWSSpotMarketOptionsBuilder contains the data and logic needed to build 'AWS_spot_market_options' objects.
//
// Spot market options for AWS machine pool.
type AWSSpotMarketOptionsBuilder struct {
	bitmap_  uint32
	id       string
	href     string
	maxPrice float64
}

// NewAWSSpotMarketOptions creates a new builder of 'AWS_spot_market_options' objects.
func NewAWSSpotMarketOptions() *AWSSpotMarketOptionsBuilder {
	return &AWSSpotMarketOptionsBuilder{}
}

// Link sets the flag that indicates if this is a link.
func (b *AWSSpotMarketOptionsBuilder) Link(value bool) *AWSSpotMarketOptionsBuilder {
	b.bitmap_ |= 1
	return b
}

// ID sets the identifier of the object.
func (b *AWSSpotMarketOptionsBuilder) ID(value string) *AWSSpotMarketOptionsBuilder {
	b.id = value
	b.bitmap_ |= 2
	return b
}

// HREF sets the link to the object.
func (b *AWSSpotMarketOptionsBuilder) HREF(value string) *AWSSpotMarketOptionsBuilder {
	b.href = value
	b.bitmap_ |= 4
	return b
}

// Empty returns true if the builder is empty, i.e. no attribute has a value.
func (b *AWSSpotMarketOptionsBuilder) Empty() bool {
	return b == nil || b.bitmap_&^1 == 0
}

// MaxPrice sets the value of the 'max_price' attribute to the given value.
//
//
func (b *AWSSpotMarketOptionsBuilder) MaxPrice(value float64) *AWSSpotMarketOptionsBuilder {
	b.maxPrice = value
	b.bitmap_ |= 8
	return b
}

// Copy copies the attributes of the given object into this builder, discarding any previous values.
func (b *AWSSpotMarketOptionsBuilder) Copy(object *AWSSpotMarketOptions) *AWSSpotMarketOptionsBuilder {
	if object == nil {
		return b
	}
	b.bitmap_ = object.bitmap_
	b.id = object.id
	b.href = object.href
	b.maxPrice = object.maxPrice
	return b
}

// Build creates a 'AWS_spot_market_options' object using the configuration stored in the builder.
func (b *AWSSpotMarketOptionsBuilder) Build() (object *AWSSpotMarketOptions, err error) {
	object = new(AWSSpotMarketOptions)
	object.id = b.id
	object.href = b.href
	object.bitmap_ = b.bitmap_
	object.maxPrice = b.maxPrice
	return
}
